/*8-4-2007 MRC-Epid JHZ */

proc import out=Nsp datafile='Mapping250K_Nsp.na21.annot.csv' dbms=csv replace;
     getnames=yes;
     datarow=2;
run;
proc import out=Sty datafile='Mapping250K_Sty.na21.annot.csv' dbms=csv replace;
     getnames=yes;
     datarow=2;
run;
libname annotate '.';
data nspsty;
     set nsp sty;
run;
proc contents;
run;
proc print data=nsp (obs=20);
proc print data=sty (obs=20);
run;
data annotate.nspsty (drop=dbSNP_RS_ID chromosome allele_a allele_b);
     format a1a2 $2. rsn $15.;
     set nspsty (keep=dbSNP_RS_ID chromosome allele_a allele_b associated_gene freq_cauc
                 rename=(associated_gene=gene freq_cauc=p1p2));
     where upcase(Chromosome) ne "X";
     a1a2=compress(allele_a||allele_b);
     rsn=input(dbSNP_RS_ID,$15.);
run;

/*
# 20-2-2007 MRC-Epid JHZ

library(foreign)
Sty <- read.csv("Mapping250K_Sty.na21.annot.csv")
Nsp <- read.csv("Mapping250K_Nsp.na21.annot.csv")
write.table(Nsp,col.names=FALSE,quote=FALSE,row.names=FALSE,file="Nsp.txt",sep="\t")
write.table(Sty,col.names=FALSE,quote=FALSE,row.names=FALSE,file="Sty.txt",sep="\t")
names(Nsp)
names(Sty)

data nsp;
     infile 'Nsp.txt' dlm='09'x lrecl=8000 truncover;
     format x1-x5 x6-x13 $80. x14 $1680. x15 $200. x16-x26 $80.;
     input x1-x26;
     nsp=1;
run;
data sty;
     infile 'Sty.txt' dlm='09'x lrecl=8000 truncover;
     format x1-x5 x6-x13 $80. x14 $1680. x15 $200. x16-x26 $80.;
     input x1-x26;
     nsp=0;
run;
data annotate.nspsty;
     attrib
       x1 label="Probe.Set.ID"                  x2 label="Affy.SNP.ID"
       x3 label="dbSNP.RS.ID"                   x4 label="Chromosome"
       x5 label="Genome.Version"                x6 label="DB.SNP.Version"
       x7 label="Physical.Position"             x8 label="Strand"
       x9 label="ChrX.pseudo.autosomal.region" x10 label="Cytoband"
      x11 label="Flank"                        x12 label="Allele.A"
      x13 label="Allele.B"                     x14 label="Associated.Gene"
      x15 label="Genetic.Map"                  x16 label="Microsatellite"
      x17 label="Fragment.Length.Start.Stop"   x18 label="Freq.Asian"
      x19 label="Freq.AfAm"                    x20 label="Freq.Cauc"
      x21 label="Het.Asian"                    x22 label="Het.AfAm"
      x23 label="Het.Cauc"                     x24 label="af.asian.called"
      x25 label="af.afam.called"               x26 label="af.cauc.called";
      set nsp sty;
run;
proc contents;
run;
proc print data=nsp (obs=20);
proc print data=sty (obs=20);
run;
*/
