/*15-2-2008 MRC-Epid JHZ*/

%macro tosnptest(i, n=3270);
data map&i (drop=nchr);
     set map;
     by chr rsn;
     if substr("&i",1,1)="0" then nchr=compress("&i","0");
     else nchr="&i";
     if chr=nchr;
     inmap=1;
run;
data data&i;
     infile "Obesity_Illuminus_dbSNP_gt_&i..ok" dlm='09'x firstobs=2 lrecl=50000;
     format rsn $15. g1-g&n $5.;
     input rsn g1-g&n;
     array g g1-g&n;
     do over g;
        if g='0 0' | g='N N' then g='';
     end;
     indata=1;
run;
proc sort data=data&i;
     by rsn;
run;
data chr&i (drop=s1 s2);
     merge map&i data&i;
     by rsn;
     array a1a2 g1-g&n;
     array acgt aa ca ga ta ab cb gb tb;
     do over acgt;
        acgt=0;
     end;
     do over a1a2;
        s1=substr(a1a2,1,1);
        s2=substr(a1a2,3,1);
        select (s1);
        when ('A') aa=aa+1;
        when ('C') ca=ca+1;
        when ('G') ga=ga+1;
        when ('T') ta=ta+1;
        otherwise;
        end;
        select (s2);
        when ('A') ab=ab+1;
        when ('C') cb=cb+1;
        when ('G') gb=gb+1;
        when ('T') tb=tb+1;
        otherwise;
        end;
     end;
     if inmap=1 & indata=1;
run;
proc sort data=chr&i;
     by pos;
run;
data x.chr&i (drop=i j s t s1 s2 aa ca ga ta ab cb gb tb);
     set chr&i;
     by pos;
     file "geno&i..txt" lrecl=50000;
     array acgt[4] at ct gt tt;
     acgt[1]=aa+ab;
     acgt[2]=ca+cb;
     acgt[3]=ga+gb;
     acgt[4]=ta+tb;
     format a1 a2 $1.;
     do i=1 to 4;
        if acgt[i]>0 then goto ok1;
     end;
ok1:s=i;
     do j=4 to s by -1;
        if acgt[j]>0 then goto ok2;
     end;
ok2:t=j;
     a1=substr('ACGT',s,1);
     a2=substr('ACGT',t,1);
     array a1a2 g1-g&n;
     do over a1a2;
        s1=substr(a1a2,1,1);
        s2=substr(a1a2,3,1);
        a1a2="0 0 0";
        if (s1=a1) & (s2=a1) then a1a2="1 0 0";
        if (s1=a1) & (s2=a2) then a1a2="0 1 0";
        if (s1=a2) & (s2=a2) then a1a2="0 0 1";
     end;
     put "--- " rsn pos a1 a2 " " g1-g&n;
run;
%mend;

%macro all2snptest;
%do chr=22 %to 1 %by -1;
    %let nchr=&chr;
    %if &chr<10 %then %let nchr=0&chr;
    %tosnptest(&nchr);
%end;
%mend;

libname x '.';
data map317 (drop=build);
     infile 'ILMN_HumanHap300_SNPlist.txt' dlm='09'x firstobs=2;
     format rsn $15. chr $2. build 2.;
     input rsn build chr pos;
run;
proc sort data=map317 out=map;
     by chr rsn;
run;

%tosnptest(XY);
%tosnptest(X);
%all2snptest;

/*
dos2unix ILMN_HumanHap300_SNPlist.txt is required
*/
