/*31-10-2007 MRC-Epid JHZ*/

%let home=/data/genetics/GWA/Obesity/sep-2007/Illuminus/;
%let scratch=/data/genetics/scratch/jhz22/;

%macro w2l (chr,label);
%if &chr<10 %then %let i=0&chr;
%if 10<=&chr<22 %then %let i=&chr;
%if &chr=23 %then %let i=X;
%if &chr=24 %then %let i=XY;
%if &label=case %then %do;
    %sysexec zcat &home.Obesity_Illuminus_gt_CASES_&i..txt.gz>&scratch.case_&i..txt;
    %sysexec awk -f Illumina.awk &scratch.case_&i..txt>&scratch.case&i..txt;
    %sysexec rm &scratch.case_&i..txt;
    filename dat "&scratch.case&i..txt";
%end;
%else %do;
      %sysexec zcat &home.Obesity_Illuminus_gt_CONTROLS_&i..txt.gz>&scratch.control_&i..txt;
      %sysexec awk -f Illumina.awk &scratch.control_&i..txt>&scratch.control&i..txt;
      %sysexec rm &scratch.control_&i..txt;
      filename dat "&scratch.control&i..txt";
%end;
proc import datafile=dat out=dat&i dbms=tab replace;
     getnames=yes;
run;
%let fid=%sysfunc(open(dat&i));
%let nvars=%sysfunc(attrn(&fid,nvars));
%let start=2;
%let end=%eval(&nvars);
%let nsnps=%eval(&end-&start+1);
%let snp1=%sysfunc(varname(&fid,&start));
%let snpn=%sysfunc(varname(&fid,&end));
data _null_;
     %if &label=case %then %do;
         file "&scratch.case&i..txt" dlm='09'x;
     %end;
     %else %do;
         file "&scratch.control&i..txt" dlm='09'x;
     %end;
     set dat&i;
     array snps &snp1.--&snpn;
     %do col=&start %to &end;
         %let rsn=%sysfunc(varname(&fid,&col));
         rsn="&rsn";
         %let snp=%eval(&col-&start+1);
         add=snps[&snp];
         put id rsn add;
     %end;
run;
%let rc=%sysfunc(close(&fid));
%if &label=case %then %do;
    %sysexec gzip &scratch.case&i..txt;
%end;
%else %do;
    %sysexec gzip -f &scratch.control&i..txt;
%end;
proc sql;
     drop table dat&i;
quit;
%mend w2l;

%macro w2l_all;
%do chr=22 %to 22;
    %w2l (chr,case);
    %w2l (chr,control);
%end;
%mend w2l_all;

options mprint;
%w2l_all;
