/*22-3-2007 MRC-Epid JHZ*/

%macro allele(i,btrait=case,qtrait=bmi);
proc sort data=scratch.data&i;
     by id;
run;
data scratch.data&i (drop=t);
     a1a2='  ';
     merge scratch.data&i epic5k.trait (drop=age);
     by id;
     t=a1;
     if a1>a2 then do;
        a1=a2;
        a2=t;
     end;
     a1a2=compress(a1||a2);
run;
ods select none;
proc means data=scratch.data&i;
     where cohort='1';
     class rsn sex a1a2;
     var &qtrait;
     output out=means&i mean=m n=n std=s;
run;
proc sort data=scratch.data&i;
     by rsn;
run;
proc freq data=scratch.data&i;
     by rsn;
     table &btrait*sex*a1a2 / out=freq&i;
run;
ods select all;
data a1a2 (drop=sex &btrait &qtrait a1a2 a1 a2);
     set scratch.data&i;
     if sex=2 then do;
        a=a1;output;
        a=a2;output;
     end;
     else if sex=1 then do;
        a=a1;output;
     end;
run;
ods select none;
proc sort data=a1a2;
     by rsn;
run;
proc freq data=a1a2;
     by rsn;
     ods output onewayfreqs=a;
     table a;
run;
ods select all;
proc sql;
     create table ma0 as select rsn, table, a, frequency, percent 
            from a group by rsn having frequency=min(frequency);
quit;
proc sort data=ma0;
     by rsn a;
run;
data ma&i;
     set ma0;
     by rsn a;
     if percent=50 & last.rsn then delete;
run;
data scratch.g&i (drop=frequency percent table);
     merge ma&i scratch.data&i (drop=a1a2);
     by rsn;
     a1a2=compress(a1||'/'||a2);
     if a1a2='/' then a1a2='   ';
run;
proc sql;
     create table long&i as select * 
            from scratch.g&i order by id;
quit;
data long&i;
     merge epic5k.trait long&i;
     by id;
     if sex=1 then do;
        if compress(a1a2) ne "" then do;
           dom=(a1=a);
           add=(a1=a)*2;
        end;
     end;
     else if sex=2 then do;
        if compress(a1a2) ne "" then do;
           dom=(a1=a | a2=a);
           add=(a1=a)+(a2=a);
        end;
     end;
run;
proc sql;
     create table scratch.long&i as select * 
            from long&i order by rsn, id;
quit;
options nonotes;
ods select none;
proc reg data=scratch.long&i (where=(compress(rsn) ne "" & cohort="1"));
     ods output anova=anova&i parameterestimates=parms&i;
     by rsn;
     add: model &qtrait=add / b stb;
     dom: model &qtrait=dom / b stb;
quit;
data parms&i (drop=variable);
     set parms&i (where=(variable ne "Intercept") drop=label);
run;
proc logistic descending data=scratch.long&i (where=(compress(rsn) ne ""));
     by rsn;
     ods output parameterestimates=pm&i CLOddsPL=clpm&i;
     model &btrait=add / expb clodds=pl;
run;
proc logistic descending data=scratch.long&i (where=(compress(rsn) ne ""));
     by rsn;
     ods output parameterestimates=dom&i CLOddsPL=cldom&i;
     model &btrait=dom / expb clodds=pl;
run;
ods select all;
data pm&i (where=(variable ne "Intercept"));
     set pm&i dom&i;
run;
proc sort data=pm&i;
     by rsn;
run;
data clpm&i;
     set clpm&i cldom&i;
run;
proc sort data=clpm&i;
     by rsn;
run;
options notes;
%mend allele;

/*
data scratch.g&i (drop=frequency percent table);
     merge ma a1a2 (rename=(ab=a1a2));
     by rsn;
     if (a1a2 ne ' ') then g=(a1a2=ab);
run;
proc sql;
     create table long&i as select * 
            from scratch.g&i order by id;
quit;
data long&i;
     merge epic5k.trait long&i;
     by id;
run;
proc sql;
     create table scratch.long&i as select * 
            from long&i order by rsn, id;
quit;
options nonotes;
ods select none;
proc genmod data=scratch.long&i (where=(rsn ne '   ')) descend;
     ods output parameterestimates=pm&i;
     by rsn;
     class id;
     model &btrait=g / dist=bin;
     repeated subject=id;
run;
proc genmod data=scratch.long&i (where=(cohort='1'));
     ods output GEEEmpPEst=anova&i ParameterEstimates=parms&i;
     by rsn;
     class id;
     model &qtrait=g / type3 wald;
     repeated subject=id;
quit;
ods select all;
options notes;
*/
