/*27-1-2008 MRC-Epid JHZ*/

%macro import (major,minor);
proc import out=p datafile="chr&major-&minor..out" dbms=DLM replace;
     getnames=yes;
     datarow=2;
     guessingrows=32767;
run;
data p&minor;
     set p;
     array beta y_add_proper_beta_1 y_dom_proper_beta_1 y_rec_proper_beta_1;
     array   se y_add_proper_se_1 y_dom_proper_se_1 y_rec_proper_se_1;
     array    p y_add_proper_p y_dom_proper_p y_rec_proper_p;
     do over beta;
        if se^=-1 & se^=. then p=2*(1-probnorm(abs(beta/se)));
     end;
run;
data _null_;
     call system("rm chr&major-&minor..out");
run;
%mend;

%macro assemble (major);
proc datasets library=x nolist;
     delete chr&major;
run;
%do minor=1 %to 30;
    %import(&major,&minor);
    proc datasets force nolist library=x;
         append base=chr&major data=work.p&minor;
    quit;
    %if &minor>1 %then %do;
    proc datasets nolist library=x;
         modify chr&major;
         attrib rsid format=$15.;
    quit;
    %end;
%end;
%mend;

%macro assemble_all;
proc datasets library=x nolist;
     delete snptest;
quit;
%do i=1 %to 22;
    %assemble(&i);
    data chr&i;
         chr=&i;
         set x.chr&i;
    run;
    proc datasets force nolist library=x;
         append base=snptest data=chr&i;
    quit;
    %if &i>1 %then %do;
    proc datasets nolist library=x;
         modify snptest;
         attrib rsid format=$15.;
    quit;
    %end;
%end;
proc sort data=x.snptest nodupkey;
     by rsid;
run;
proc contents data=x.snptest varnum;
run;
%mend;

options ps=max ls=max nocenter nonotes;
libname x '.';
%assemble_all;
