/*11-5-2007 MRC-Epid JH Zhao*/

%let home=/data/genetics/GWA/Obesity/apr-2007/;

libname obesity '/data/genetics/GWA/6-5-7/obesity500k';
libname scratch '/data/genetics/GWA/6-5-7/calls';
libname epic5k '.';

options mprint;

data ob;
     infile "&home.Affx_sample_OB.txt" dlm='09'x firstobs=2;
     format id $15.;
     input id$ gender cohort$ supplier$ well$ region$;
run;
data obc;
     infile "&home.Affx_sample_OBC.txt" dlm='09'x firstobs=2;
     format id $15.;
     input id$ gender cohort$ supplier$ well$ region$;
run;
data obobc;
     set ob obc;
run;
proc sort data=obobc;
     by id;
run;
proc sql;
     create table exclude as select * from epic5k.exclude;
     create table id as select id from obobc
                  where id not in (select wtccc_id from exclude);
quit;

%macro snpcall(i);
proc sql;
     %if &i<10 %then %do;
     create table scratch.long&i as select * from obesity.long0&i
                  where id in (select id from id);
     %end;
     %else %do;
     create table scratch.long&i as select * from obesity.long&i
                  where id in (select id from id);
     %end;
quit;
proc summary data=scratch.long&i noprint;
     class rsn;
     var dom;
     output out=scratch.snpcalls&i n=n;
run;
data scratch.snpcalls&i;
     set scratch.snpcalls&i;
     format p 4.2;
     p=n/_FREQ_;
run;
proc datasets library=scratch;
     delete long&i;
run;
%mend snpcall;

%macro snpcalls;
%do i=1 %to 22;
    %snpcall(&i);
%end;
%snpcall(X);
%mend snpcalls;

%snpcalls;
