/*4-11-2007 MRC-Epid JHZ*/

%macro geno;
%do i=1 %to 22;
    %if &i<10 %then %let j=0&i;
    %else %do;
        %if &i=23 %then %let j=X;
        %else %let j=&i;
    %end;
    proc transpose data=obesity.long&j (keep=id rsn add) out=long&j;
         var add;
         by rsn;
         id id;
    run;
    data long&j (drop=rsnn);
         set long&j (rename=(rsn=rsnn));
         rsn=tranwrd(rsnn,"A-","A_");
    run;
    proc sort data=epic5k.map&j out=map&j;
         by location;
    run;
    data map&j;
         set map&j;
         bp=dif(location);
         if _n_=1 then do;
            M=0;
            bp=0;
         end;
         M=bp/100000000;
    run;
    proc sort data=map&j;
         by rsn;
    run;
    data map&j (drop=rsnn);
         set map&j (rename=(rsn=rsnn));
         rsn=tranwrd(rsnn,"A-","A_");
    run;
    data long&j;
         merge long&j (drop=_name_) map&j (keep=rsn chr location);
         by rsn;
    run;
    proc sort data=long&j;
         by location;
    run;
    proc datasets force;
         append base=obesity.geno data=long&j;
         append base=epic5k.map data=map&j;
    run;
%end;
%mend geno;

%macro wide;
%do i=1 %to 23;
    %if &i<10 %then %let j=0&i;
    %else %do;
        %if &i=23 %then %let j=X;
        %else %let j=&i;
    %end;
    data scratch.add&j;
         set obesity.long&j (keep=id rsn add zheight);
         chr=&j;
    run;
    proc sort data=scratch.add&j sortsize=8G;
         by id zheight;
    run;
    proc transpose data=scratch.add&j out=add&j;
         var add;
         id rsn;
         by chr id zheight;
    run;
    proc datasets library=scratch force;
         append base=scratch.wide data=add&j;
         append base=scratch.map data=epic5k.map&j;
         delete add&j;
    quit;
%end;
%mend wide;

options missing=9 mprint;
%let home=/data/genetics/scratch/;
libname epic5k '.';
libname obesity '/data/genetics/GWA/6-5-7/obesity500k';
libname scratch "&home";

%geno;

data snps (where=(1<=chr<=22));
     set scratch.snps;
run;
data geno;
     set obesity.geno;
     rsn=tranwrd(rsn,"A_","A-");
run;
data map (drop=rsnn);
     set epic5k.map(rename=(rsn=rsnn));
     rsn=tranwrd(rsnn,"A_","A-");
run;
proc sql;
     create table scratch.geno as select * from geno
                  where rsn in (select rsn from snps);
     create table scratch.map as select * from map
                  where rsn in (select rsn from snps);
quit;
data _null_;
     set scratch.geno (drop=location rsn chr);
     file "&home.epic5k.geno" lrecl=50000;
     put (_all_) (1.);
run;
proc sort data=scratch.map;
     by chr location;
run;
data scratch.map;
     set scratch.map;
     by chr location;
     bp=dif(location);
     if first.chr then do;
        M=0;
        bp=0;
     end;
     M=bp/100000000;
run;
data _null_;
     set scratch.map;
     file "&home.epic5k.snp";
     put rsn $15. chr 5. M 12.5 bp 12.;
run;
proc format;
     value agefmt low-<50='1' 50-<60='2' 60-<70='3' 70-high='4';
run;
data ind;
     set epic5k.trait (keep=id sex zheight);
     if sex=1 then gender="M"; else if sex=2 then gender="F";
     file "&home.epic5k.ind";
     pop="EPIC-Norfolk";
     put id $15. gender $5. pop;
run;
data pheno;
     set epic5k.trait (keep=zheight);
     file "&home.epic5k.phenoQTL";
     put zheight 10.8;
run;

/*
%include ds2text;
%ds2text(data=scratch.geno, fileref=geno, heading=none, delim=);
%wide;
%ds2text(data=scratch.wide, fileref=geno, heading=none);
*/
