/*1-2-2006 MRC-Epid JHZ*/

%macro btfdr;
proc sort data=scratch.btpm (rename=(locus=rsn));
     by rsn;
run;
proc sort data=map;
     by rsn;
run;
data pm;
     merge btpm map;
     by rsn;
run;
title2 false discover rate;
proc sort data=pm;
     by chr location;
run;
data pv;
     set pm;
     test=compress('test'||_n_);
     rename probtrend=raw_p;
run;
ods select none;
proc multtest pdata=pv out=ps fdr pvals;
run;
ods select all;
proc sort data=ps out=scratch.pbt;
     by location;
run;
proc print data=scratch.pbt (where=(fdr_p^=.));
     where fdr_p <= 0.05;
run;
%mend btfdr;

%macro qtfdr;
proc sort data=scratch.btpm (rename=(locus=rsn));
     by rsn;
run;
proc sort data=map;
     by rsn;
run;
data pm;
     merge btpm map;
     by rsn;
run;
proc sort data=pm;
     by chr location;
run;
data pv;
     set pm;
     where variable ne 'Intercept' and probt ne .;
     test=compress('test'||_n_);
     rename probt=raw_p;
run;
ods select none;
proc multtest pdata=pv out=ps fdr pvals;
run;
ods select all;
proc sort data=ps (drop=dependent variable label test) out=scratch.pqt;
     by location;
run;
proc print data=scratch.pqt (where=(fdr_p^=.));
     where fdr_p <= 0.05;
run;
%mend qtfdr;

%macro btfdri;
ods select all;
data pm;
     merge scratch.pm&i (rename=(locus=rsn)) map&i (drop=name allele1 allele2);
     by rsn;
run;
title2 false discover rate;
proc sort data=pm;
     by chr location;
run;
data pv;
     set pm;
     test=compress('test'||_n_);
     rename probtrend=raw_p;
run;
ods select none;
proc multtest pdata=pv out=ps fdr pvals;
run;
ods select all;
proc sort data=ps out=scratch.pbt&i;
     by location;
run;
proc print data=scratch.pbt&i (where=(fdr_p^=.));
     where fdr_p <= 0.05;
run;
%mend btfdri;

%macro qtfdri;
ods select all;
title2 summary reports;
data pm;
     merge scratch.parms&i map&i (drop=name allele1 allele2);
     by rsn;
run;
proc sort data=pm;
     by chr location;
run;
data pv;
     set pm;
     where variable ne 'Intercept' and probt ne .;
     test=compress('test'||_n_);
     rename probt=raw_p;
run;
ods select none;
proc multtest pdata=pv out=ps fdr pvals;
run;
ods select all;
proc sort data=ps (drop=dependent variable label test) out=scratch.pqt&i;
     by location;
run;
proc print data=scratch.pqt&i (where=(fdr_p^=.));
     where fdr_p <= 0.05;
run;
%mend qtfdri;

%macro allsnps;
%do i=1 %to 24;
data map;
     infile "Affx_20061113fa1_snp_&i..txt" dlm='09'x;
     input idn rsn$ chr pos a1$ a2$;
run;
proc append base=epic5k.map data=map;
run;
%end;
%do i=1 %to 22;
proc append base=btpm data=scratch.pm&i;
run;
%end;
proc append base qtpm data=scratch.pm&i;
run;
%btfdr;
%qtdfr;
%mend allsnps;
