/*1-5-2007 MRC-Epid JHZ*/

%include setup;  /* set up options and paths */
%include map;	 /* map information */
%include data;   /* genotype data */
%include ld;     /* LD plot */

%macro extract(i);
proc sql;
     create table long as select * 
            from obesity.long&i where rsn in (select rsn from rsn);
     create table scratch.long as select *
            from long as a left join rsn as b on a.rsn=b.rsn
            order by pos;
quit;
proc sort data=scratch.long;
     by id age sex bmi case cohort;
run;
proc transpose data=scratch.long out=scratch.a1a2&i;
     var a1a2;
     id rsn;
     by id age sex bmi case cohort;
run;
proc transpose data=scratch.long out=scratch.add&i;
     var add;
     id rsn;
     by id age sex bmi case cohort;
run;
proc transpose data=scratch.long out=scratch.dom&i;
     var dom;
     id rsn;
     by id age sex bmi case cohort;
run;
proc transpose data=scratch.long out=scratch.rec&i;
     var rec;
     id rsn;
     by id age sex bmi case cohort;
run;
%mend extract;

%*map(16);
%*data(16);
%*include exclude;/* individuals to be excluded*/

libname obesity '/data/genetics/GWA/1-5-7/obesity500k';
libname scratch '/data/genetics/scratch';

proc format;
     value agefmt low-<40='1' 40-<50='2' 50-<60='3' 60-<70='4' 70-high='5';
run;
%ld(16,startpos=52290376,endpos=52710882);

data rsn;
     infile 'ld16_rs7202836-rs2075205.info' dlm='09'x;
     format rsn $15.;
     input rsn$ pos;
     rsn=compress(rsn);
run;

%extract(16);
