/*9-5-2007 MRC-Epid JHZ*/

%include setup;  /* set up options and paths */
%include map;	 /* map information */
%include trait;  /* trait information */
%include desc;   /* summary statistics */
%include exclude;/* a list of individuals to be excluded*/
%include data;	 /* genotype data */
%include split;  /* data splitting */
%include code;   /* minor and major alleles */
%include pg;	 /* merge of phenotype and genotype */
%include bt;	 /* binary trait analysis (LOGISTIC) */
%include qt;	 /* quantitative trait analysis */
%include hwe;    /* Hardy-Weinberg equilibrium tests*/
%include ld;     /* LD plot */
%include tidy;   /* space release */
%include fdr; 	 /* false discovery rate */
%include allele; /* chromosome X analysis */
%include xhwe;   /* Hardy-Weinberg equilibrium tests for chromosome X */

%macro do_chr(i,ns=30);
%map(&i);
%data(&i);

%split(&i,ns=&ns);
%do j=1 %to &ns;
    proc sql;
         create table scratch.data&i as select a.rsn, a.id, substr(a1a2,1,1) as a1, substr(a1a2,2,1) as a2
                from obesity.data&i as a, rsn&i as b where a.rsn=b.rsn and group=&j;
         create table scratch.map&i (drop=nn group rsn) as select * 
                from rsn&i where group=&j;
    quit;
    %if %upcase(&i)=X %then %do;
        %allele(&i);
        %hwe(&i,where=where sex=2);
        %xhwe(data=scratch.data&i,where=where cohort="1");
        %if (&j=1) %then %do;
            proc sql;
                 create table scratch.chisq&i as select * from chisq;
            quit;
        %end;
        %else %do;
            proc append base=scratch.chisq&i data=chisq;
            run;
        %end;
    %end;
    %else %do;
        %code(&i);
        %pg(&i);
        %hwe(&i);
        %desc(&i);
        %bt(&i,trait=case);
        %qt(&i,trait=bmi);
    %end;
    proc datasets;
         append base=obesity.long&i data=scratch.long&i;
         append base=scratch.cma&i data=ma&i;
         append base=scratch.cpm&i data=pm&i;
         append base=scratch.clpm&i data=clpm&i;
         append base=scratch.canova&i data=anova&i;
         append base=scratch.cparms&i data=parms&i;
         append base=scratch.caf&i data=af&i;
         append base=scratch.cms&i data=ms&i;
         append base=scratch.cmeans&i data=means&i;
         append base=scratch.cfreq&i data=freq&i;
    quit;
    %tidy(&i);
%end;
%mend do_chr;

%do_chr(01);
%do_chr(02);
%do_chr(03);
%do_chr(04);
%do_chr(05);
%do_chr(06);
%do_chr(07);
%do_chr(08);
%do_chr(09);
%do_chr(10);
%do_chr(11);
%do_chr(12);
%do_chr(13);
%do_chr(14);
%do_chr(15);
%do_chr(16);
%do_chr(17);
%do_chr(18);
%do_chr(19);
%do_chr(20);
%do_chr(21);
%do_chr(22);
%do_chr(X);

/* Command to run with space in /scratch: sas -work /scratch go.sas & */
