/*6-12-2007 MRC-Epid JHZ*/

options mprint;
libname epic5k '/home/jhz22/mrc/projects/epic5k';
libname latest '/data/genetics/GWA/impute/ruth';
proc format;
     value agefmt low-<50='1' 50-<60='2' 60-<70='3' 70-high='4';
run;
title phenotypic information;
data waist;
     set latest.waiststand (keep=id zL10waist zL10WHT zL10WHT2 zL10WHR zL10WHRHT2);
run;
proc sort data=waist;
     by id;
run;
proc sql;
     create table trait as select id, cohort, sex, zheight, bmi, zbmi from epic5k.trait order by id;
     create table qctrait as select id, cohort, age, height, weight, waist, hip
            from latest.gwaobesity_pheno_affyqc order by id;
quit;
data ntrait;
     merge trait qctrait waist;
     by id;
     age2=age*age;
     height=height/100;
     if height>0 then wht2=waist/height/height;
     if hip>0 then wh=waist/hip;
run;
proc sort data=ntrait (where=(cohort="1")) out=cohort;
     by sex;
run;
proc rank data=cohort out=rtrait normal=blom;
     by sex;
     var bmi waist wht2 wh;
     ranks rbmi rwaist rwht2 rwh;
run;
proc sql;
     create table idex as select * from ntrait where id in (select id from qctrait) order by id;
     create table idex2 as select * from rtrait where id in (select id from qctrait) order by id;
quit;
data id epic5k.id;
     merge idex idex2 (keep=id rbmi rwaist rwht2 rwh);
     by id;
     idn=_n_;
run;
%macro out (outfile,if=);
data _null_;
     set id;
     by id;
     &if;
     array mis &varlist;
     do over mis;
        if mis=. then mis=-9;
     end;
     file &outfile;
     put idn id &varlist;
run;
%mend out;
%let varlist=zheight;
%out("zheight.raw");

%let varlist=zbmi;
%out("zbmi.raw",if=if cohort='1');

%let varlist=age zL10waist zL10WHT2 zL10WHR zL10WHT;
%out("best.raw",if=if cohort='1');

%let varlist=age bmi zL10WHT2 zL10WHRHT2;
%out("cecilia.raw",if=if cohort='1');

%let varlist=age age2 bmi rbmi rwht2 rwh;
%out("uniform1.raw",if=if cohort='1');

%let varlist=age age2 height rwaist;
%out("uniform2.raw",if=if cohort='1');

data _null_;
     set id (where=(cohort="1"));
     by id;
     file 'idex.dat';
     put idn;
run;
data _null_;
     set id (where=(cohort="1" & sex=1));
     by id;
     file 'male.dat';
     put idn;
run;
data _null_;
     set id (where=(cohort="1" & sex=2));
     by id;
     file 'female.dat';
     put idn;
run;
/*
proc sql;
     create table exclude as select * from x.exclude;
     create table idex as select * from x.trait
            where id not in (select wtccc_id from exclude);
     create table trait as select * from x.trait;
     create table idex2 as select * from x.trait (where=(cohort="1"))
            where id in (select wtccc_id from exclude);
quit;
data cohort (where=(cohort="1"));
     set idex;
     idn=_n_;
     array mis height zheight bmi zbmi;
     do over mis;
        if mis=. then mis=-9;
     end;
run;
data _null_;
     set cohort;
     file 'idex.dat';
     put idn;
run;
data _null_;
     set cohort;
     file 'cohort.raw';
     put id idn height zheight bmi zbmi;
run;

data stdtrait;
     set ntrait;
     zbmi=log10(bmi);
     zheight=height;
run;
proc standard data=stdtrait out=stdheight mean=0 std=1;
     by sex age;
     var zheight;
     format age agefmt.;
run;
proc sort data=stdtrait;
     by cohort sex age;
run;
proc standard data=stdtrait out=stdbmi mean=0 std=1;
     by cohort sex age;
     var zbmi;
     format age agefmt.;
run;
proc sql;
     create table x.trait as select a.cohort, a.id, a.case, a.age, a.sex, a.hba1c, a.hdl, a.height, a.zheight,
                                    a.bmi, b.zbmi from stdheight a left join stdbmi b on a.id=b.id;
quit;
proc sort data=x.trait;
     by id cohort case age sex bmi zbmi height zheight hba1c hdl;
run;
ods select none;
proc reg data=rtrait;
     ods output OutputStatistics=os (keep=model residual);
     by sex;
     u1: model rbmi=age age2 / r;
     u2: model bmi=age age2 / r;
     u3: model rwaist=age age2 height / r;
     u4: model rwht2=age age2 / r;
     u5: model rwh=age age2 / r;
run;
ods select all;
data _null_;
     set id (where=(cohort="0"));
     by id;
     file 'idex.sample';
     put idn;
run;
*/
