/*2-10-2007 MRC-Epid JHZ*/

title;
options nocenter ps=max ls=max spool nonotes nosource;
libname here '.';
libname obesity '/data/genetics/GWA/6-5-7/obesity500k';
libname scratch '/data/genetics/scratch/jhz22';
proc format;
     value agefmt low-<50='1' 50-<60='2' 60-<70='3' 70-high='4';
run;
%global nobs;
%macro count(dsn);
data _null_;
     if 0 then set &dsn nobs=count;
     call symput('nobs',left(put(count,16.)));
     stop;
run;
%mend count;

%macro geno(i, ns=30);
proc sql;
     create table scratch.map&i as select * from here.b35 (where=(chr=&i))
            where rsn in (select rsn from here.snpid) order by pos;
     create table map as select * from scratch.map&i order by rsn;
quit;
%count(scratch.map&i);
data scratch.map&i;
     set scratch.map&i;
     by pos;
     nn=&nobs;
     group=ceil(&ns/nn*_n_);
run;
proc summary data=scratch.map&i noprint;
     by group;
     var pos;
     output out=minmax min=min max=max n=n;
run;
data _null_;
     do j=1 to &ns;
        i=&i;
        set minmax;
        put "make -f epic5k.sh NO=" i "MINOR=" j "REGION=" "" min max "";
     end;
run;
%if &i<10 %then %let j=0&i; %else %let j=&i;
proc sql;
     create table long&j as select * from obesity.long&j where id in (select id from here.sampleid);
quit;
proc transpose data=long&j out=scratch.long&j (drop=_name_);
     id id;
     by rsn;
     var a1a2;
run;
data map (drop=rsnn);
     format rsn $15.;
     set map (rename=(rsn=rsnn));
     rsn=tranwrd(rsnn,"A-","A_");
run;
data scratch.geno&i (drop=a1 a2 swap);
     merge map scratch.long&j;
     by rsn;
     array wtccc wtccc139236--wtccc147447;
     do over wtccc;
        a1=substr(wtccc,1,1);
        a2=substr(wtccc,3,1);
        a1s=allele1;
        a2s=allele2;
        swap=0;
        if rsn="rs2429893" then do;
           allele1="A";
           allele2="G";
           a1s="T";
           a2s="C";
           swap=1;
        end;
        if rsn="rs2664070" then do;
           allele1="C";
           allele2="T";
           a1s="G";
           a1s="A";
           swap=1;
        end;
        if strand="-" and rsn ^in ("rs4886982","rs10967532","rs3960362") then do;
           allele1=translate(a1,"ACGT","TGCA");
           allele2=translate(a2,"ACGT","TGCA");
           if allele1>allele2 then swap=1;
        end;
        wtccc="0 0 0";
        if (a1=allele1 & a2=allele1) & swap=1 then wtccc="1 0 0";
        else if ((a1=allele1 & a2=allele2)|(a1=allele2 & a2=allele1)) then wtccc="0 1 0";
        else if (a1=allele2 & a2=allele2) & swap=1 then wtccc="0 0 1";
     end;
run;
proc sort data=scratch.geno&i;
     by pos;
run;
%do k=1 %to &ns;
    proc sql;
         create table map&i._&k (drop=nn group rsn) as select * from scratch.map&i where group=&k;
         create table geno&i._&k as select a.* from scratch.geno&i as a, scratch.map&i as b where a.rsn=b.rsn & group=&k;
    quit; 
    data _null_;
         file "geno&i-&k..txt" lrecl=30000000;
         format id$ 15. rsn $15. rsnn $15.;
         set geno&i._&k (rename=(rsn=rsnn));
         rsn=tranwrd(rsnn,"A_","A-");
         id=setid1;
         if substr(rsnn,1,3)="SNP" then id=rsn;
         a1=a1s;
         a2=a2s;
         if swap=1 then do;
            a1=a2s;
            a2=a1s;
         end;
         put id rsn pos a1 a2 (wtccc139236--wtccc147447) ($6.);
    run;
%end;
%mend geno;

%geno(1);
%geno(2);
%geno(3);
%geno(4);
%geno(5);
%geno(6);
%geno(7);
%geno(8);
%geno(9);
%geno(10);
%geno(11);
%geno(12);
%geno(13);
%geno(14);
%geno(15);
%geno(16);
%geno(17);
%geno(18);
%geno(19);
%geno(20);
%geno(21);
%geno(22);
