/*18-1-2008 MRC-Epid JHZ*/

libname map '/data/genetics/gwas/map';
libname obesity '/data/genetics/GWA/6-5-7/obesity500k';
libname scratch '/data/genetics/scratch';
libname x '.';
%global nobs;
%macro count(dsn);
data _null_;
     if 0 then set &dsn nobs=count;
     call symput('nobs',left(put(count,16.)));
     stop;
run;
%mend count;
%macro geno(i, ns=30);
%if &i<10 %then %let j=0&i; %else %let j=&i;
proc sql;
     create table long&j as select * from obesity.long&j
            where id in (select id from x.sampleid);
     create table scratch.map&i as select * from map.map (where=(chr=&i));
     create table map as select * from scratch.map&i order by rsn;
quit;
proc transpose data=long&j out=scratch.long&j (drop=_name_);
     id id;
     by rsn;
     var a1a2;
run;
data map (drop=rsnn);
     format rsn $15.;
     set map (rename=(rsn=rsnn));
     rsn=tranwrd(rsnn,"A-","A_");
     allele1=a1;
     allele2=a2;
     if strand="-" then do;
        allele1=translate(a1,"ACGT","TGCA");
        allele2=translate(a2,"ACGT","TGCA");
     end;
     if allele1>allele2 then do;
        t=allele2;
        allele2=allele1;
        allele1=t;
     end;
run;
data scratch.geno&i (drop=a1 a2);
     merge map (keep=rsn pos allele1 allele2 setid) scratch.long&j;
     by rsn;
     array wtccc wtccc139236--wtccc147447;
     do over wtccc;
        a1=substr(wtccc,1,1);
        a2=substr(wtccc,3,1);
        wtccc="0 0 0";
        if (a1=allele1 & a2=allele1) then wtccc="1 0 0";
        else if ((a1=allele1 & a2=allele2)|(a1=allele2 & a2=allele1)) then wtccc="0 1 0";
        else if (a1=allele2 & a2=allele2) then wtccc="0 0 1";
     end;
run;
proc sort data=scratch.geno&i;
     by pos;
run;
%count(scratch.map&i);
data scratch.map&i (drop=rsnn);
     set scratch.map&i (rename=(rsn=rsnn));
     by pos;
     nn=&nobs;
     group=ceil(&ns/nn*_n_);
     rsn=tranwrd(rsnn,"A-","A_");
run;
%do k=1 %to &ns;
    proc sql;
         create table geno&i._&k
                as select a.* from scratch.geno&i as a, scratch.map&i as b
                where a.rsn=b.rsn & group=&k;
    quit; 
    data _null_;
         file "geno&i-&k..txt" lrecl=30000000;
         format id$ 15. rsn $15. rsnn $15.;
         set geno&i._&k (rename=(rsn=rsnn));
         rsn=tranwrd(rsnn,"A_","A-");
         id=setid;
         put id rsn pos allele1 allele2 (wtccc139236--wtccc147447) ($6.);
    run;
    proc sql;
         drop table geno&i._&k;
    quit;
%end;
proc summary data=scratch.map&i noprint;
     by group;
     var pos;
     output out=minmax min=min max=max n=n;
run;
data _null_;
     do j=1 to &ns;
        i=&i;
        set minmax;
        put "make -f epic5k.sh NO=" i "MINOR=" j "REGION=" "" min max "";
     end;
run;
%mend geno;
%macro impute;
%do i=2 %to 1 %by -1;
    %geno(&i);
%end;
%mend;
title;
options nocenter ps=max ls=max spool nonotes nosource mprint;
%impute;
