/*2-10-2007 MRC-Epid JHZ*/

options mprint;
libname x '.';
libname epic5k '~/mrc/projects/epic5k';

%macro v1;
proc sql;
     drop table legstr;
     drop table v1;
     create table map as select * from epic5k.map order by chr, location;
quit;
%do i=1 %to 22;
data map&i;
     infile "v1/CEU_files/genetic_map_chr&i..txt" firstobs=2;
     input pos m1 m2;
run;
proc import datafile="v1/genotypes_chr&i._CEU_r21_nr_fwd_legend_all_no_mono" out=legend&i dbms=dlm replace;
     delimiter=' ';
     getnames=yes;
     datarow=2;
run;
data haplotype&i;
     infile "v1/genotypes_chr&i._CEU_r21_nr_fwd_phased_all_by_snp_no_mono" lrecl=500;
     input h1-h120;
run;
data strand&i;
     infile "v1/CEU_files/chr&i..strand";
     input pos strand$;
run;
proc sql;
     create table legstr&i as select * from legend&i (rename=(position=pos))
                  where pos in (select pos from strand&i);
quit;
data legstr&i;
     set legstr&i;
     chr=&i;
     posv1=pos;
run;
data map&i;
     set map&i;
     chr=&i;
     posv1=pos;
run;
proc datasets;
     append base=v1 data=map&i force;
     append base=legstr data=legstr&i force;
quit;
%end;
data x.v1map;
     merge legstr map (rename=(location=pos) drop=rsn);
     by chr pos;
run;
data x.v1;
     merge v1 map (rename=(location=pos) drop=rsn);
     by chr pos;
run;
%mend v1;

%v1;

%macro impute_ex;
data map;
     infile 'example/map.txt' firstobs=2;
     input pos m1 m2;
run;
proc import out=legend datafile='example/legend.txt' dbms=dlm replace;
     delimiter=' ';
     getnames=yes;
     datarow=2;
run;
data haplotype;
     infile 'example/haplo.txt';
     input h1-h120;
run;
data strand;
     infile 'example/strand.txt';
     input pos strand$;
run;
data geno;
     infile 'example/geno.txt';
     format id $15. rsn $15.;
     input id$ rsn$ pos a1$ a2$ i1-i3 j1-j3 k1-k3;
run;
data out;
     infile 'out';
     format id $15. rsn $15.;
     input id$ rsn$ pos a1$ a2$ i1-i3 j1-j3 k1-k3;
run;
data info;
     infile 'info';
     format id $15. rsn $15.;
     input id$ rsn$ pos score brier;
run;

proc sql;
     create table over as select * from map where pos not in (select pos from geno);
     create table over2 as select * from over where pos in (select position from legend);
     select * from over;
     select * from over2;
quit;
%mend impute_ex;
