/*23-3-2007 MRC-Epid JHZ*/

%macro ld(i,startsnp=,endsnp=,startpos=0,endpos=0,run=0,forld=0);
%global snp1 snp2 pos1 pos2;
proc sort data=epic5k.map&i out=map&i;
     by location;
run;
%if &startsnp ne and &endsnp ne %then %do;
data _null_;
     set map&i (where=(rsn in ("&startsnp","&endsnp")) keep=rsn location);
     if _n_=1 then call symput('pos1',compress(put(location,16.)));
     else if _n_=2 then call symput('pos2',compress(put(location,16.)));
     call symput('snp1',trim(input("&startsnp",$15.)));
     call symput('snp2',trim(input("&endsnp",$15.)));
run;
data snps;
     set map&i;
     where (location>=&pos1 & location<=&pos2);
     put rsn= '09'x location=;
run;
%end;
%else %if &startpos ne and &endpos ne %then %do;
data snps;
     set map&i (where=(&startpos<=location<=&endpos) keep=rsn location);
     call symput('pos1',compress(put(&startpos,15.)));
     call symput('pos2',compress(put(&endpos,15.)));
     put rsn= '09'x location=;
run;
%count(snps);
data _null_;
     set snps (obs=1);
     call symput('snp1',trim(input(rsn,$15.)));
data _null_;
     set snps (firstobs=&nobs);
     call symput('snp2',trim(input(rsn,$15.)));
run;
%end;
data _null_;
     file "ld&i._&snp1.-&snp2..info";
     set snps (keep=rsn location);
     put rsn '09'x location;
run;
proc sort data=snps;
     by rsn;
run;
proc sql;
     create table dat as select a.rsn,a.id,substr(a1a2,1,1) as a1, substr(a1a2,2,1) as a2,b.location
            from obesity.data&i as a, snps as b 
            where a.rsn=b.rsn order by rsn, id;
     create table dat2 (drop=location) as select * from dat order by id, location;
quit;
data dat;
     set dat2;
     b1=substr(translate(a1,'01234',' ACGT'),1,1);
     b2=substr(translate(a2,'01234',' ACGT'),1,1);
     t=compress(b1||'/'||b2);
     b1b2=tranwrd(t,'/',' ');
     keep rsn id b1b2;
run;
proc transpose data=dat out=ped (drop=_NAME_);
     id rsn;
     by id;
     var b1b2;
run;
data ped;
     pid=_n_;id="               ";fid=0;mid=0;sex=1;aff=1;
     set ped;
     %if &forld=1 %then %do;
         if _n_>=%eval(&cases-&excases);
     %end;
run;
filename pedfile "ld&i._&snp1.-&snp2..ped";
%ds2text(data=ped, fileref=pedfile, heading=none);
data _null_;
     put "LD plot for chromosome &i, &snp1-&snp2, position &pos1-&pos2";
     %if &run^=0 %then %do;
         call system("java -jar haploview.jar -pedfile ld&i.-&snp1.-&snp2..ped -info ld&i.-&pos1.-&pos2..info");
     %end;
run;
%mend ld;
