/*9-5-2007 MRC-Epid JHZ*/

%include setup;  /* set up options and paths */
%include trait;  /* trait information */
%include data;   /* genotype data */
%include split;  /* data splitting */
%include code;   /* minor and major alleles */
%include pg;	 /* merge of phenotype and genotype */
%include hwe;    /* Hardy-Weinberg equilibrium tests*/
%include xhwe;   /* Hardy-Weinberg equilibrium tests for chromosome X */
%include allele; /* chromosome X analysis */

%macro merge_all(i,ns=30);
%do k=1 %to 23;
    %if &k<10 %then %let i=0&k;
    %else %do;
        %if &k=23 %then %let i=X;
        %else %let i=&k;
    %end;
    %data(&i);
    %split(&i,ns=&ns);
    %do j=1 %to &ns;
        proc sql;
             create table scratch.data&i as select a.rsn, a.id, substr(a1a2,1,1) as a1, substr(a1a2,2,1) as a2
                    from obesity.data&i as a, rsn&i as b where a.rsn=b.rsn and group=&j;
        quit;
        %if %upcase(&i)=X %then %do;
            %allele(&i);
            %hwe(&i,where=where sex=2);
            %xhwe(data=scratch.data&i);
        %end;
        %else %do;
            %code(&i);
            %pg(&i);
            %hwe(&i);
        %end;
        proc datasets;
             append base=obesity.long&i data=scratch.long&i;
             append base=scratch.caf&i data=af&i;
             append base=scratch.cms&i data=ms&i;
             append base=scratch.caaf&i data=aaf&i;
             append base=scratch.cams&i data=ams&i;
        quit;
    %end;
%end;
%mend merge_all;

%merge_all();
