/*4-5-2007 MRC-Epid JHZ*/

libname zheight '/data/genetics/GWA/1-5-7/zheight';

%macro nhwe(lib=,data=);
proc sort data=&lib..&data out=a;
     by rsn a1a2;
run;
data a;
     set a (rename=(n=w));
     by rsn;
     lines=1;
     if first.rsn then n=1;
     else n+1;
     format gid lid $3.;
     gid=compress('g'||n);
     lid=compress('l'||n);
run;
proc summary data=a;
     by rsn;
     var lines;
     output out=n n=;
run;
data g;
     merge a n;
     by rsn;
run;
proc transpose data=a out=b (drop=_name_);
     by rsn;
     var a1a2;
     id lid;
run;
proc transpose data=a out=c (drop=_name_);
     by rsn;
     var w;
     id gid;
run;
data bc;
     merge b c;
     by rsn;
run;
data &lib..hwe&data (keep=rsn x2_hwe p p1 p2 g1-g3 l1-l3);
     set bc (rename=(g1=s1 g2=s2 g3=s3));
     by rsn;
     format a1-a4 $1.;
     array a a1-a4;
     array r r1-r4;
     array s s1-s3;
     array g g1-g3;
     array e e1-e3;
     array x x1-x3;
     n3=n(of s1-s3);
     select (n3);
        when (3) do;
          do over g;
             g=s;
          end;
        end;
        when (2) do;
          a1=substr(l1,1,1);
          a2=substr(l1,3,1);
          a3=substr(l2,1,1);
          a4=substr(l2,3,1);
          do over r;
             r=rank(a);
          end;
          minor=min(of r1-r4);
          major=max(of r1-r4);
          if a1=byte(minor) and a2=byte(major) then do;
             g3=s2;
             g2=s1;
          end;
          else do;
             g1=s1;
             g2=s2;
          end;
        end;
        when (1) do;
          a1=substr(l1,1,1);
          a2=substr(l1,3,1);
          if a1 eq a2 then g1=s1;
          else g2=s1;
        end;
        otherwise;
     end;
     do over g;
        if g=. then g=0;
     end;
     n1=2*g1+g2;
     n2=2*g3+g2;
     n=n1+n2;
     p1=n1/n;
     p2=1-p1;
     t=g1+g2+g3;
     e1=p1**2*t;
     e2=2*p1*p2*t;
     e3=p2**2*t;
     do over g;
        if e^=0 then x=(g-e)**2/e;
     end;
     x2_hwe=sum(of x1-x3);
     p=1-probchi(x2_hwe,1);
run;
%mend nhwe;

%nhwe(lib=zheight,data=means01);
%nhwe(lib=zheight,data=means02);
%nhwe(lib=zheight,data=means03);
%nhwe(lib=zheight,data=means04);
%nhwe(lib=zheight,data=means05);
%nhwe(lib=zheight,data=means06);
%nhwe(lib=zheight,data=means07);
%nhwe(lib=zheight,data=means08);
%nhwe(lib=zheight,data=means09);
%nhwe(lib=zheight,data=means10);
%nhwe(lib=zheight,data=means11);
%nhwe(lib=zheight,data=means12);
%nhwe(lib=zheight,data=means13);
%nhwe(lib=zheight,data=means14);
%nhwe(lib=zheight,data=means15);
%nhwe(lib=zheight,data=means16);
%nhwe(lib=zheight,data=means17);
%nhwe(lib=zheight,data=means18);
%nhwe(lib=zheight,data=means19);
%nhwe(lib=zheight,data=means20);
%nhwe(lib=zheight,data=means21);
%nhwe(lib=zheight,data=means22);
%nhwe(lib=zheight,data=meansX);

/*
data a;
input rsn$ a1a2$ n;
datalines;
rsn1 a1/a1 10
rsn1 a1/a2 3
rsn1 a2/a2 5
rsn2 a1/a1 10
rsn2 a1/a2 3
rsn2 a2/a2 5
;

%nhwe(lib=work,data=a);

*/
