/*25-6-2007 MRC-Epid JHZ*/

%include setup;  /* set up options and paths */
%include data;   /* genotype data */
%include split;  /* data splitting */
%include code;   /* minor and major alleles */
%include pg;     /* merge of phenotype and genotype */
%include hwe;    /* Hardy-Weinberg equilibrium tests*/
%include xhwe;   /* Hardy-Weinberg equilibrium tests for chromosome X */
%include allele; /* chromosome X analysis */
%include qlim;   /* Qualitative and LImited dependent variable Model */

%macro qlim_all(trait,ns=30,lib=&trait);
%do k=1 %to 23;
    %if &k<10 %then %let i=0&k;
    %else %do;
        %if &k=23 %then %let i=X;
        %else %let i=&k;
    %end;
    %data(&i);
    %split(&i,ns=&ns);
    %do j=1 %to &ns;
        proc sql;
             create table scratch.data&i as select a.rsn, a.id, substr(a1a2,1,1) as a1, substr(a1a2,2,1) as a2
                    from obesity.data&i as a, rsn&i as b where a.rsn=b.rsn and group=&j;
        quit;
        %if %upcase(&i)=X %then %do;
            %allele(&i);
            %hwe(&i,where=where sex=2);
            %xhwe(data=scratch.data&i);
        %end;
        %else %do;
            %code(&i);
            %pg(&i);
            %hwe(&i);
        %end;
        %let data=scratch.long&i;
        %qlim(&i,data=&data,trait=&trait);
        %qlim(&i,data=&data,trait=&trait,x=dom);
        %if %upcase(&i)^=X %then %do;
            %qlim(&i,data=&data,trait=&trait,x=rec);
        %end;
        data qlim&i (where=(parameter ne "Intercept"));
             %if %upcase(&i)^=X %then %do;
                 set add dom rec;
             %end;
             %else %do;
                 set add dom;
             %end;
        run;
        proc datasets;
             append base=&lib...cafcase&i data=af&i force;
             append base=&lib...cmscase&i data=ms&i force;
             append base=&lib...qlim&i data=qlim&i force;
        quit;
    %end;
%end;
%mend qlim_all;

options mprint;
title2 quantitative trait in cases;
%let latest=/data/genetics/GWA/6-5-7/;
libname obesity "/data/genetics/scratch/obesity500k";
libname bmi "&latest.bmi";
libname hdl "&latest.hdl";
libname hba1c "&latest.hba1c";
libname scratch '/scratch';

%qlim_all(bmi);

/*
%include qlim;
%macro qlim_all;
%do i=1 %to 23;
    %if &i<10 %then %let j=0&i;
    %else %do;
        %if &i=23 %then %let j=X;
        %else %let j=&i;
    %end;
    %let data=obesity.long&j;
    %qlim(&i,data=&data);
    %qlim(&i,data=&data,x=dom);
    %qlim(&i,data=&data,x=rec);
    data scratch.parms&i (where=(parameter ne "Intercept"));
         set add dom rec;
    run;
    data scratch.mills&i (where=(parameter ne "Intercept"));
         set madd mdom mrec;
    run;
%end;
%mend qlim_all;

%qlim_all;
*/
