/*9-5-2007 MRC-Epid JHZ*/

title2 quantitative trait analysis;
%macro qt(trait,where=(cohort="1"),lib=&trait);
%do i=1 %to 23;
    %if &i<10 %then %let j=0&i;
    %else %do;
        %if &i=23 %then %let j=X;
        %else %let j=&i;
    %end;
    %*merge(&j);
    ods select none;
    proc reg data=obesity.long&j (where=&where);
         where compress(rsn) ne "";
         ods output ParameterEstimates=parms&j;
         by rsn;
         add: model &trait=add /b stb;
         dom: model &trait=dom /b stb;
         %if &i<23 %then %do;
         rec: model &trait=rec /b stb;
         %end;
    quit;
    data parms&j (drop=variable);
         set parms&j (where=(variable ne "Intercept"));
    run;
    proc datasets library=work;
         copy out=&lib move;
         select parms&j;
    quit;
    proc means data=obesity.long&j;
         where &where;
         class rsn a1a2;
         var &trait;
         output out=&lib...means&j (where=(compress(rsn) ne "" & compress(a1a2) ne "")) mean=m n=n std=s;
    run;
%end;
%mend qt;

title2 HWE of the whole sample;
%macro hwe(where=,lib=);
%do i=1 %to 23;
    %if &i<10 %then %let j=0&i;
    %else %do;
        %if &i=23 %then %do;
            %let j=X;
            %let where=where sex=2;
        %end;
        %else %let j=&i;
    %end;
    ods select none;
    proc sort data=obesity.long&j (keep=rsn id sex a1a2 cohort) out=control&j (drop=cohort sex);
         &where;
         by id rsn;
    run;
    proc transpose data=control&j out=control2&j (drop=_NAME_ id);
         id rsn;
         by id;
         var a1a2;
    run;
    proc allele data=control2&j genocol;
         var _CHARACTER_;
         ods output markersumm=&lib...ms&j allelefreq=&lib...af&j;
    run;
    ods select all;
%end;
%mend hwe;

options mprint;
libname epic5k '.';
libname obesity '/data/genetics/GWA/6-5-7/obesity500k';
libname scratch '/data/genetics/scratch';

%let latest=/data/genetics/GWA/6-5-7/;
libname bmi "&latest.bmi";
libname zbmi "&latest.zbmi";
libname zheight "&latest.zheight";
libname hdl "&latest.hdl";
libname hba1c "&latest.hba1c";

%qt(hdl);
%qt(hba1c);

/*
%macro merge(j);
proc sql;
     create table long&j (drop=age a1a2)
                  as select a.*, b.hba1c, b.hdl, b.zheight, b.zbmi
                  from obesity.long&j a left join epic5k.stddata b on a.id=b.id;
     create table scratch.long&j as select * from long&j order by rsn;
     drop table long&j;
quit;
%mend merge;

%qt(zbmi);
%qt(zheight,where=(cohort in ("0","1")));
%hwe(where=where cohort="1",lib=zbmi);
%hwe(where=where cohort in ("0","1"),lib=zheight);
*/
