/*17-1-2008 MRC-Epid JHZ*/

libname ruth '/data/genetics/GWA/impute/ruth';
libname cr '/data/genetics/GWA/6-5-7/calls';
libname hwe '/data/genetics/GWA/6-5-7/hwe_all';
libname map '/data/genetics/gwas/map';
libname x '.';

title sample id;
data x.sampleid;
     set ruth.gwaobesity_pheno_affyqc (keep=id);
run;
%macro snpQC;
proc datasets library=x;
     delete cr af ms;
quit;
%do i=1 %to 22;
    %if &i<10 %then %let j=0&i; %else %let j=&i;
    proc datasets force;
         append base=x.cr data=cr.snpcalls&i;
         append base=x.af data=hwe.caaf&j;
         append base=x.ms data=hwe.cams&j;
    quit;
%end;
%mend;
%snpQC;
proc sort data=x.cr out=cr;
     by rsn;
proc sort data=x.af out=af (rename=(locus=rsn));
     by locus;
proc sort data=x.ms out=ms (rename=(locus=rsn));
     by locus;
run;
proc summary data=af;
     by rsn;
     var freq;
     output out=maf min=maf;
run;
data snpid;
     merge cr maf ms;
     by rsn;
     if p+maf+probchisq^=. & p>=0.9 & maf>=0.01 & probchisq>1e-6;
run;
data x.snpid;
     set snpid (rename=(rsn=rsnn));
     format rsn $15.;
     rsn=tranwrd(rsnn,"A_","A-");
     keep rsn;
run;
title SNP id;
data b35 (drop=chrn);
     set map.affy500snps (rename=(chr=chrn) where=(chrn^='X'));
     chr=chrn+0;
run;
proc sql;
     create table x.map as select * from b35 
     where rsn in (select rsn from x.snpid) order by chr,pos;
quit;
