/*26-4-2007 MRC-Epid JHZ*/

%macro sum;
%do i=1 %to 22;
%if &i=1 %then %do;
    proc sql;
         create table map as select * from epic5k.map0&i;
         create table af as select * from scratch.caf0&i;
    quit;
    data ma;
         set scratch.cma0&i;
         format rsn $15.;
    run;
    proc sql;
         create table ms as select * from scratch.cms0&i;
         create table means as select * from scratch.cmeans0&i;
         create table freq as select * from scratch.cfreq0&i;
         create table pm as select * from scratch.cpm0&i;
         create table clpm as select * from scratch.clpm0&i;
         create table anova as select * from scratch.canova0&i;
         create table parms as select * from scratch.cparms0&i;
         create table calls as select rsn, p from scratch.snpcalls&i(where=(compress(rsn)^=""));
    quit;
%end;
%else %do;
      %if &i<10 %then %do;
          proc append base=map data=epic5k.map0&i;
          proc append base=af data=scratch.caf0&i;
          data cma0&i;
               format rsn $15.;
               set scratch.cma0&i;
          run;
          proc append base=ma data=cma0&i;
          proc append base=ms data=scratch.cms0&i;
          proc append base=means data=scratch.cmeans0&i;
          proc append base=freq data=scratch.cfreq0&i;
          proc append base=pm data=scratch.cpm0&i;
          proc append base=clpm data=scratch.clpm0&i;
          proc append base=anova data=scratch.canova0&i;
          proc append base=parms data=scratch.cparms0&i;
          proc append base=calls data=scratch.snpcalls&i (where=(compress(rsn)^="") keep=rsn p);
          run;
      %end;
      %else %do;
          proc append base=map data=epic5k.map&i;
          proc append base=af data=scratch.caf&i;
          data cma&i;
               set scratch.cma&i;
          run;
          proc append base=ma data=cma&i;
          proc append base=ms data=scratch.cms&i;
          proc append base=means data=scratch.cmeans&i;
          proc append base=freq data=scratch.cfreq&i;
          proc append base=pm data=scratch.cpm&i;
          proc append base=clpm data=scratch.clpm&i;
          proc append base=anova data=scratch.canova&i;
          proc append base=parms data=scratch.cparms&i;
          proc append base=calls data=scratch.snpcalls&i (where=(compress(rsn)^="") keep=rsn p);
          run;
      %end;
%end;
%end;
%if 0 %then %do;
    proc append base=map data=epic5k.mapx;
    proc append base=af data=scratch.cafx;
    proc append base=ms data=scratch.cmax;
    proc append base=pm data=scratch.cpmx;
    proc append base=clpm data=scratch.clpmx;
    proc append base=anova data=scratch.canovax;
    proc append base=anova data=scratch.cparmsx;
    proc append base=calls data=scratch.snpcallsx (where=(compress(rsn)^="") keep=rsn p);
    run;
%end;
%mend sum;

%include setup;
%include bc58;
libname scratch '/data/genetics/GWA/25-4-7';
proc sort data=affy500k.nspsty out=affy500k;
     by rsn;
%sum;
data map (drop=rsnn allele1 allele2);
     format rsn $15.;
     set map (rename=(rsn=rsnn));
     rsn=tranwrd(rsnn,"A-","A_");
run;
proc sort data=map (drop=name);
     by rsn;
run;
data allele (drop=controlvar);
     set af (rename=(locus=rsn));
run;
proc sort data=allele;
     by rsn;
run;
proc transpose data=allele out=l;
     by rsn;
     var allele;
run;
proc transpose data=allele out=c;
     by rsn;
     var count;
run;
proc transpose data=allele out=f;
     by rsn;
     var freq;
run;
proc transpose data=allele out=stderr;
     by rsn;
     var stderr;
run;
data allele (drop=_name_ _label_);
     merge l (rename=(col1=aa1 col2=aa2))
           c (rename=(col1=cc1 col2=cc2))
           f (rename=(col1=ff1 col2=ff2))
           stderr (rename=(col1=ss1 col2=ss2));
     by rsn;
run;
data ma (drop=rsnn);
     format rsn $15.;
     set ma (rename=(rsn=rsnn));
     rsn=tranwrd(rsnn,"A-","A_");
run;
proc sort data=ma;
     by rsn;
run;
proc sort data=ms (rename=(locus=rsn chisq=x2hwe probchisq=phwe) drop=nallele df);
     by rsn;
run;
proc sort data=means;
     by rsn;
run;
proc transpose data=means out=l;
     by rsn;
     var a1a2;
run;
proc transpose data=means out=m;
     by rsn;
     var m;
run;
proc transpose data=means out=s;
     by rsn;
     var s;
run;
proc transpose data=means out=n;
     by rsn;
     var n;
run;
data lmsn (drop=l1-l3);
     merge l (rename=(col1=l1 col2=l2 col3=l3))
           m (rename=(col1=m1 col2=m2 col3=m3))
	   s (rename=(col1=s1 col2=s2 col3=s3))
           n (rename=(col1=nn1 col2=nn2 col3=nn3));
     format g $11.;
     g=compress(l1||","||l2||","||l3);
     by rsn;
run;
proc sort data=freq;
     by rsn;
run;
proc transpose data=freq (where=(a1a2 ne "")) out=label;
     by rsn;
     var a1a2;
run;
proc transpose data=freq (where=(a1a2 ne "")) out=count;
     by rsn;
     var count;
run;
data lc (drop=l1-l9);
     merge label (rename=(col1=l1 col2=l2 col3=l3 col4=l4 col5=l5 col6=l6 col7=l7 col8=l8 col9=l9))
           count (rename=(col1=c1 col2=c2 col3=c3 col4=c4 col5=c5 col6=c6 col7=c7 col8=c8 col9=c9));
     format gg $23.;
     gg=compress(l1||","||l2||","||l3||";"||l4||","||l5||","||l6||","||l7||","||l8||","||l9);
     by rsn;
run;
proc sort data=pm (rename=(variable=model));
     by rsn model;
run;
proc transpose data=pm out=m;
     by rsn;
     var model;
run;
proc transpose data=pm out=b;
     by rsn;
     var estimate;
run;
proc transpose data=pm out=se;
     by rsn;
     var stderr;
run;
proc transpose data=pm out=p;
     by rsn;
     var probchisq;
run;
data pm (drop=_label_ _name_ m1-m3);
     merge m (rename=(col1=m1 col2=m2 col3=m3))
           b (rename=(col1=b11 col2=b12 col3=b13))
	   se (rename=(col1=se11 col2=se12 col3=se13))
           p (rename=(col1=pchi1 col2=pchi2 col3=pchi3));
     by rsn;
     format pm $11.;
     pm=compress(m1||","||m2||","||m3);
run;
proc sort data=clpm (drop=unit);
     by rsn effect;
run;
data clpm (drop=effect);
     set clpm;
     model=input(effect,$9.);
run;
proc transpose data=clpm out=m;
     by rsn;
     var model;
run;
proc transpose data=clpm out=or;
     by rsn;
     var oddsratioest;
run;
proc transpose data=clpm out=ll;
     by rsn;
     var lowercl;
run;proc transpose data=clpm out=ul;
     by rsn;
     var uppercl;
run;
data clpm (drop=_name_ _label_ m1-m3);
     merge m  (rename=(col1=m1 col2=m2 col3=m3))
           or (rename=(col1=or1 col2=or2 col3=or3))
           ll (rename=(col1=ll1 col2=ll2 col3=ll3))
           ul (rename=(col1=ul1 col2=ul2 col3=ul3));
     by rsn;
     format clpm $11.;
     clpm=compress(m1||","||m2||","||m3);
run;
proc sort data=anova (where=(upcase(compress(source))="MODEL"));
     by rsn model;
run;
data anova (drop=m32);
     set anova (rename=(model=m32));
     by rsn m32;
     model=input(m32,$9.);
run;
proc transpose data=anova out=m;
     by rsn;
     var model;
run;
proc transpose data=anova out=f;
     by rsn;
     var Fvalue;
run;
proc transpose data=anova out=pF;
     by rsn;
     var probF;
run;
data anova (drop=_label_ _name_ m1-m3);
     merge m (rename=(col1=m1 col2=m2 col3=m3))
           F (rename=(col1=F1 col2=F2 col3=F3))
           pF (rename=(col1=PF1 col2=PF2 col3=PF3));
     by rsn;
     format anova $11.;
     anova=compress(m1||","||m2||","||m3);
run;
proc sort data=parms;
     by rsn model;
run;
data parms (drop=m32);
     set parms (rename=(model=m32));
     model=input(m32,$9.);
run;
proc transpose data=parms out=m;
     by rsn;
     var model;
run;
proc transpose data=parms out=b;
     by rsn;
     var estimate;
run;
proc transpose data=parms out=t;
     by rsn;
     var tvalue;
run;
proc transpose data=parms out=se;
     by rsn;
     var stderr;
run;
proc transpose data=parms out=pt;
     by rsn;
     var probt;
run;
proc transpose data=parms out=stb;
     by rsn;
     var standardizedest;
run;
data call (drop=rsnn);
     format rsn $15.;
     set calls (rename=(p=snpcall));
     rsn=tranwrd(rsnn,"A-","A_");
run;
proc sort data=calls (rename=(p=snpcall));
     by rsn;
run;
data parms (drop=_label_ _name_ m1-m3);
     merge m (rename=(col1=m1 col2=m2 col3=m3))
           b (rename=(col1=b21 col2=b22 col3=b23))
           t (rename=(col1=t1 col2=t2 col3=t3))
	   se (rename=(col1=se21 col2=se22 col3=se23))
	   pt (rename=(col1=pt1 col2=pt2 col3=pt3))
	   stb (rename=(col1=stb1 col2=stb2 col3=stb3));
     by rsn;
     format parms $11.;
     parms=compress(m1||","||m2||","||m3);
run;
data ccbmi (drop=_label_ _name_ where=(1<=chr<=22));
     merge map allele ma ms lmsn lc pm clpm anova parms affy500k bc58 calls;
     by rsn;
     probchisq=min(of pchi1-pchi3);
     probF=min(of pF1-pF3);
     logpChisq=-log10(probchisq);
     logpF=-log10(probF);
     pdiff=(cc1*ff1+maf*&bc58n)/(cc1+&bc58n);
     pdiff=2*(1-probnorm(abs(ff1-maf)/sqrt(pdiff*(1-pdiff)*(1/cc1+1/&bc58n))));
     attrib
       Div label = 'Allelic Diversity'
       F1-F3 label = 'F Value from ANOVA'
       Het label = 'Heterozygosity'
       NIndiv label ='Number of Individuals'
       PIC label ='Polymorph Info Content'
       Pchi1-Pchi3 label = 'Pr > Chi-Square'
       PF1-PF3 label = 'Pr > F'
       Pt1-Pt3 label = 'Pr > |t|'
       a1 label = 'the 1st allele'
       a2 label = 'the 2nd allele'
       a1a2 label = 'alleles from Affymetrix'
       aa1 label = 'the 1st allele from PROC ALLELE'
       aa2 label = 'the 2nd allele from PROC ALLELE'
       anova label = 'label for linear regression ANOVA'
       b11-b13 label = 'logistic regression coefficient'
       b21-b23 label = 'linear regression coefficient'
       stb1-stb3 label = 'standardised estimate of linear regression coefficient'
       c1 label = 'count for the 1st genotype in controls'
       c2 label = 'count for the 2nd genotype in controls'
       c3 label = 'count for the 3rd genotype in controls'
       c4 label = 'count for the 1st genotype in cases'
       c5 label = 'count for the 2nd genotype in cases'
       c6 label = 'count for the 3rd genotype in cases'
       cc1 label = 'count for the 1st allele from PROC ALLELE'
       cc2 label = 'count for the 2nd allele from PROC ALLELE'
       chr label = 'chromosome'
       clpm label = 'labels for logistic regression (CL)'
       ff1 label = 'frequency of the 1st allele from PROC ALLELE'
       ff2 label = 'frequency of the 2nd allele from PROC ALLELE'
       g  label  = 'genotype labels'
       gg label  = 'case-control genotype labels'
       ll1-ll3 label = 'Profile Likelihood Lower 95%CL for Adjusted Odds Ratio'
       location label = 'position of the SNP on a chromosome'
       logpChisq label = '-log10(p2) from the logistic regression'
       logpF label = '-log10(p1) from the logistic regression'
       m1 label = 'mean for the 1st genotype'
       m2 label = 'mean for the 2nd genotype'
       m3 label = 'mean for the 3rd genotype'
       n1 label = 'count of the 1st allele'                                                                 
       n2 label = 'count of the 2nd allele'
       nn1 label = 'count of the 1st genotype from PROC MEANS'
       nn2 label = 'count of the 2nd genotype from PROC MEANS'
       nn3 label = 'count of the 3rd genotype from PROC MEANS'
       or1-or3 label = 'OR from logistic regression'
       p1 label = 'frequency of the 1st allele'
       p2 label = 'frequency of the 2nd allele'
       p1p2 label = 'allele frequencies from hapmap'
       parms label = 'label for linear regression'
       phwe label = 'p value for HWE test'
       pm label = 'labels for logistic regresison'
       rsn label = 'SNP name'
       s1 label = 'standard error for the 1st genotypic mean'
       s2 label = 'standard error for the 2nd genotypic mean'
       s3 label = 'standard error for the 3rd genotypic mean'
       se11-se13 label = 'standard error of logistic regression coefficient'
       se21-se23 label = 'standard error of linear regression coefficient'
       ss1 label = 'standard error of allele 1 frequency from PROC ALLELE'
       ss2 label = 'standard error of allele 2 frequency from PROC ALLELE'
       t1-t3 label = 't value for the linear regression coefficient'
       ul1-ul3 label = 'Profile Likelihood Upper 95%CL for Adjusted Odds Ratio'
       x2hwe label = 'Chi-Square for HWE test'
       pdiff label = 'Pr >!z| testing for allele frequency difference with BC58';
run;
data scratch.ccbmi (drop=rsnn);
     format rsn $15.;
     set ccbmi (rename=(rsn=rsnn));
     rsn=tranwrd(rsnn,"A_","A-");
run;
proc contents data=scratch.ccbmi;
run;
proc sql;
     create table pm as select chr, rsn, p1, pm, b11-b13, pchi1-pchi3, clpm, or1-or3, 
              anova, F1-F3, pF1-pF3, parms, b21-b23, probchisq, logpChisq, logpF, 
              a1a2, p1p2, gene from scratch.ccbmi (where=(probchisq^=.)) order by probchisq;
     title Logistic regression;
     select * from pm (obs=200);
     create table anova as select chr, rsn, p1, pm, b11-b13, pchi1-pchi3, clpm, or1-or3,
              anova, F1-F3, pF1-pF3, probF, parms, b21-b23, logpChisq, logpF, 
              a1a2, p1p2, gene from scratch.ccbmi (where=(probF^=.)) order by probF;
     title Linear regression;
     select * from anova (obs=200);
quit;
