/*7-2-2007 MRC-Epid JHZ*/

%include setup; /* set up options and paths */
%include map;	/* map information */
%include trait; /* trait information */
%include desc;  /* summary statistics */
%include data;	/* genotype data */
%include split; /* data splitting */
%include code;  /* minor and major alleles */
%include pg;	/* merge of phenotype and genotype */
%include bt;	/* binary trait analysis (LOGISTIC) */
%include qt;	/* quantitative trait analysis */
%include hwe;   /* Hardy-Weinberg equilibrium tests*/
%include ld;    /* LD plot */
%include tidy;  /* space release */
%include fdr; 	/* false discovery rate */
%include allele;/* chromosome X analysis */
%include xhwe;  /* Hardy-Weinberg equilibrium tests for chromosome X */

%macro do_chr(i,ns=1);
%*map(&i);
%*data(&i);

%split(&i,ns=&ns);
%do j=1 %to &ns;
    proc sql;
         create table scratch.data&i as select a.rsn, a.id, substr(a1a2,1,1) as a1, substr(a1a2,2,1) as a2
                from obesity.data&i (where=(rsn in ("rs3883014","rs3883011","rs3883013","rs2336967"))) as a, 
                rsn&i as b where a.rsn=b.rsn and group=&j;
         create table scratch.map&i (drop=nn group rsn) as select * from rsn&i where group=&j;
         create table scratch.control&i as select a.rsn, a.id, substr(a1a2,1,1) as a1, substr(a1a2,1,2) as a2
                from obesity.control&i (where=(rsn in ("rs3883014","rs3883011","rs3883013","rs2336967"))) as a,
                rsn&i as b where a.rsn=b.rsn and group=&j;
    quit;
    %if %upcase(&i)=X %then %do;
        %allele(&i);
        %xhwe(data=scratch.data&i); 
        %if (&j=1) %then %do;
            proc sql;
                 create table scratch.cmeans&i as select * from means&i;
                 create table scratch.cfreq&i as select * from freq&i;
                 create table scratch.cpm&i as select * from pm&i;
                 create table scratch.cparms&i as select * from parms&i;
                 create table scratch.chisq&i as select * from chisq;
            quit;
        %end;
        %else %do;
            proc append base=scratch.cmeans&i data=means&i;
            proc append base=scratch.cfreq&i data=freq&i;
            proc append base=scratch.cpm&i data=pm&i;
            proc append base=scratch.cparms&i data=parms&i;
            proc append base=scratch.chisq&i data=chisq;
            run;
        %end;
    %end;
    %else %do;
        %code(&i);
        %pg(&i);
        %hwe(&i);
        %desc(&i);
        %bt(&i,trait=case);
        %qt(&i,trait=bmi);
        %if (&j=1) %then %do;
            proc sql;
                 create table scratch.cpm&i as select * from pm&i;
                 create table scratch.clpm&i as select * from clpm&i;
                 create table scratch.canova&i as select * from anova&i;
                 create table scratch.cparms&i as select * from parms&i;
                 create table scratch.caf&i as select * from af&i;
                 create table scratch.cms&i as select * from ms&i;
                 create table scratch.cmeans&i as select * from means&i;
                 create table scratch.cfreq&i as select * from freq&i;
            quit;
        %end;
        %else %do;
            proc append base=scratch.cpm&i data=pm&i;
            proc append base=scratch.clpm&i data=clpm&i;
            proc append base=scratch.canova&i data=anova&i;
            proc append base=scratch.cparms&i data=parms&i;
            proc append base=scratch.caf&i data=af&i;
            proc append base=scratch.cms&i data=ms&i;
            proc append base=scratch.cmeans&i data=means&i;
            proc append base=scratch.cfreq&i data=freq&i;
            run;
        %end;
    %end;
    %*tidy(&i);
%end;
%mend do_chr;

%do_chr(15);

/* Command to run with space in /scratch: sas -work /scratch go.sas & */
