/*17-10-2007 MRC-Epid JHZ*/

libname epic5k '~/mrc/projects/epic5k';
libname wide '/data/genetics/GWA/6-5-7/wide';
libname zL10wtht '/data/genetics/GWA/6-5-7/zL10';
libname latest 'ruth';
options compress=yes nonotes;

%macro vars (data);

%let dsid=%sysfunc(open(&data));
%let varlist=;
%let nvars=%sysfunc(attrn(&dsid,nvars));

proc datasets library=work;
     delete parms;
quit;
ods select none;
%do i=1 %to &nvars;
    %let vi=%sysfunc(varname(&dsid,&i));
    %let vt=%sysfunc(vartype(&dsid,&i));
    %let in=(&vi=AGE)+(&vi=SEX)+(&vi=BMI)+(&vi=ZL10WAIST)+(&vi=ZL10WHT)+(&vi=ZL10WHT2)+(&vi=ZL10WHR)+(&vi=ZK10WHT2)+(&vi=ZL10WHRHT2);
    %if (&vt=N & &in^=1) %then %do;
        %let model1=&vi._1 : model zL10waist = age &vi / b stb;
        %let model2=&vi._2 : model zL10WHT = age &vi / b stb;
        %let model3=&vi._3 : model zL10WHT2 = age &vi / b stb;
        %let model4=&vi._4 : model zL10WHR = age &vi / b stb;
        %let model5=&vi._5 : model zL10WHT2 = age bmi &vi / b stb;
        %let model6=&vi._6 : model zL10WHRHT2 = age bmi &vi / b stb;
        proc reg data=&data;
             ods output parameterestimates=pe;
             &model1;
             &model2;
             &model3;
             &model4;
             &model5;
             &model6;
        run;
        quit;
        proc datasets;
             append base=parms data=pe force;
        quit;
    %end;
%end;
ods select all;
data zL10wtht.parms&j (drop=variable);
     set parms (where=(variable ne "Intercept") drop=label);
run;
%mend vars;

%macro vars_all;
proc sql;
     create table vars as select * from latest.waiststand order by id;
     create table trait as select id, bmi from epic5k.trait where id in (select id from vars) order by id;
quit;
%do i=1 %to 22;
%if &i<10 %then %let j=0&i; %else %do; %if &i=23 %then %let j=X; %else %let j=&i; %end;
proc sql;
     create table wide as select * from wide.add&j where id in (select id from vars) order by id;
run;
data wide;
     merge wide trait vars;
     by id;
run;
%vars(wide);
%end;
%mend vars_all;

%vars_all;
