/*31-10-2007 MRC-Epid JHZ*/

libname epic5k '~/mrc/projects/epic5k';
libname wide '/data/genetics/GWA/6-5-7/wide';
libname zL10wtht '/data/genetics/GWA/6-5-7/zL10';
libname latest 'ruth';
options compress=yes mprint ps=max;

%macro wtl(data);
%let fid=%sysfunc(open(&data));
%let nvars=%sysfunc(attrn(&fid,nvars));
%let start=10;
%let end=%eval(&nvars);
%let nsnps=%eval(&end-&start+1);
%let snp1=%sysfunc(varname(&fid,&start));
%let snpn=%sysfunc(varname(&fid,&end));
%let rc=%sysfunc(close(&fid));
data long (keep=id rsn age bmi zL10waist zL10WHT zL10WHT2 zL10WHR zL10WHRHT2 add);
     lid=open("&data");
     set &data;
     array snps &snp1.--&snpn;
     do col=&start to &end;
        rsn=varname(lid,col);
        snp=col-&start+1;
        add=snps[snp];
        output;
     end;
     rc=close(lid);
run;
%mend wtl;
%macro wtl_all;
proc sql;
     create table vars as select * from latest.waiststand order by id;
     create table trait as select id, bmi from epic5k.trait where id in (select id from vars) order by id;
quit;
%do i=23 %to 1 %by -1;
%if &i<10 %then %let j=0&i; %else %do; %if &i=23 %then %let j=X; %else %let j=&i; %end;
proc sql;
     create table wide as select * from wide.add&j where id in (select id from vars);
quit;
data wide;
%if &i=23 %then %do;
     if sex=2;
%end;
     merge trait vars wide;
     by id;
run;
%wtl(wide);
proc sql;
     create table long2 as select * from long order by rsn;
quit;
ods select none;
proc reg data=long2;
     by rsn;
     ods output parameterestimates=zL10wtht.vite&j;
     m1: model zL10waist = age add / b stb;
     m2: model zL10WHT = age add / b stb;
     m3: model zL10WHT2 = age add / b stb;
     m4: model zL10WHR = age add / b stb;
     m5: model zL10WHT2 = age bmi add / b stb;
     m6: model zL10WHRHT2 = age bmi add / b stb;
run;
ods select all;
proc sql;
     drop table long, long2;
quit;
%end;
%mend wtl_all;

%wtl_all;

/*
proc datasets nolist;
     modify long (sortedby=rsn);
     index create rsn / nomiss unique;
quit;
*/

