/*1-10-2007 MRC-Epid JHZ */

%macro b3i3(co1,co2,co3,ca1,ca2,ca3);
data b3i3;
     i=1;j=1;n=&co1;output;
     i=1;j=2;n=&ca1;output;
     i=2;j=3;n=&co2;output;
     i=2;j=1;n=&ca2;output;
     i=3;j=2;n=&co3;output;
     i=3;j=3;n=&ca3;output;
run;
proc freq data=b3i3;
     weight n;
     table i*j / chisq;
run;
%mend;
%macro x2 (i,trait);
%if &i<10 %then %let j=0&i; %else %let j=&i;
proc import datafile="basic/snptest_&trait._&j..txt" out=basic&i;
run;
data basic&i;
     set basic&i;
     rename id=id_b rsid=rsid_b allele1=a1_b allele2=a2_b frequentist_gen=p;
     i=1;
     drop good_clustering;
run;
proc sort data=basic&i;
     by pos;
run;
proc import datafile="imputation/snptest_&trait._&j..txt" out=impute&i;
run;
data impute&i;
     set impute&i;
     rename id=id_i rsid=rsid_i allele1=a1_i allele2=a2_i;
     j=1;
     drop good_clustering;
run;
proc sort data=impute&i;
     by pos;
run;
data &trait;
     merge basic&i impute&i;
     by pos;
     if i=1;
     chr=&i;
     n1=controls_aa;
     n2=controls_ab;
     n3=controls_bb;
     m1=cases_aa;
     m2=cases_ab;
     m3=cases_bb;
     i1=cases_aa_exp;
     i2=cases_ab_exp;
     i3=cases_bb_exp;
     if (n1>n3 and cases_aa_exp<cases_bb_exp) or (n1<n3 and cases_aa_exp>cases_bb_exp) then do;
        i1=cases_bb_exp;
        i3=cases_aa_exp;
     end;
     k1=sum(of n1-n3);
     k2=sum(of m1-m3);
     l1=sum(of n1 m1);
     l2=sum(of n2 m2);
     l3=sum(of n3 m3);
     N=k1+k2;
     if k1^=0 and l1^=0 then cc1=n1**2/k1/l1;
     if k2^=0 and l1^=0 then cc2=m1**2/k2/l1;
     if k1^=0 and l2^=0 then cc3=n2**2/k1/l2;
     if k2^=0 and l2^=0 then cc4=m2**2/k2/l2;
     if k1^=0 and l3^=0 then cc5=n3**2/k1/l3;
     if k2^=0 and l3^=0 then cc6=m3**2/k2/l3;
     c1=N*(sum(of cc1-cc6)-1);
     p1=1-probchi(c1,2);
     s1=sum(of n1-n3);
     s2=sum(of i1-i3);
     t1=sum(of n1 i1);
     t2=sum(of n2 i2);
     t3=sum(of n3 i3);
     W=s1+s2;
     if s1^=0 and t1^=0 then dd1=n1**2/s1/t1;
     if s2^=0 and t1^=0 then dd2=i1**2/s2/t1;
     if s1^=0 and t2^=0 then dd3=n2**2/s1/t2;
     if s2^=0 and t2^=0 then dd4=i2**2/s2/t2;
     if s1^=0 and t3^=0 then dd5=n3**2/s1/t3;
     if s2^=0 and t3^=0 then dd6=i3**2/s2/t3;
     c2=W*(sum(of dd1-dd6)-1);
     p2=1-probchi(c2,2);
     keep chr id_b rsid_b pos n1-n3 m1-m3 i1-i3 c1 c2 p p1 p2;
run;
proc corr data=&trait pearson spearman;
title "Chromosome &i";
     var p p1 p2;
run;
%mend x2;

libname x '.';
options nocenter ps=max;
%macro allx2(trait=T2D);
proc sql;
     drop table x.&trait;
quit;
%do i=1 %to 22;
%x2(&i,trait=&trait);
proc datasets;
     append base=x.&trait data=&trait force;
quit;
%end;
%mend allx2;

%allx2;
proc corr data=x.t2d pearson spearman;
     var p p1 p2;
run;
