/*6-10-2007 MRC-Epid JHZ*/

title;
options nocenter ps=max ls=max spool nosource mprint;
libname epic5k '~/mrc/projects/epic5k';
libname here '.';
libname obesity '/data/genetics/GWA/6-5-7/obesity500k';
libname scratch '/data/genetics/scratch/jhz22';
libname wide '/data/genetics/GWA/6-5-7/wide';
%global nobs;
%macro count(data);
data _null_;
     if 0 then set &data nobs=count;
     call symput('nobs',left(put(count,16.)));
     stop;
run;
%mend count;
proc format;
     value agefmt low-<50='1' 50-<60='2' 60-<70='3' 70-high='4';
run;

%macro xpose;
%do i=1 %to 23;
%if &i<10 %then %let j=0&i; %else %do; %if &i=23 %then %let j=X; %else %let j=&i; %end;
%if ns=1 %then %do;
proc sql;
     create table scratch.long&j 
            as select id,rsn,a1a2,add from obesity.long&j order by id, rsn;
quit;
proc transpose data=scratch.long&j out=wide.a1a2&j (drop=_name_);
     id rsn;
     by id;
     var a1a2;
run;
proc transpose data=scratch.long&j out=wide.add&j (drop=_name_);
     id rsn;
     by id;
     var add;
run;
proc sql;
     drop table scratch.long&j;
quit;
%end;
%else %do;
%count(epic5k.trait);
proc sql;
     create table id as select id from epic5k.trait order by id;
quit;
data id;
     set id;
     by id;
     nn=&nobs;
     group=ceil(&ns/nn*_n_);
run;
%do k=1 %to &ns;
proc sql;
     create table groupk as select id, group from id where group=&k;
     create table scratch.long&j as select id, rsn, a1a2, add
            from obesity.long&j where id in (select id from groupk);
quit;
proc sql;
     create table scratch.long&j._&k
            as select id,rsn,a1a2,add from scratch.long&j order by id, rsn;
quit;
proc transpose data=scratch.long&j._&k out=scratch.a1a2&j._&k (drop=_name_);
     id rsn;
     by id;
     var a1a2;
run;
proc transpose data=scratch.long&j._&k out=scratch.add&j._&k (drop=_name_);
     id rsn;
     by id;
     var add;
run;
%if &k=1 %then %do;
     data wide.a1a2&j;
          set scratch.a1a2&j._&k;
          by id;
     run;
     data wide.add&j;
          set scratch.add&j._&k;
          by id;
     run;
%end;
%else %do;
      data wide.a1a2&j;
           merge wide.a1a2&j scratch.a1a2&j._&k;
           by id;
      run;
      data wide.add&j;
           merge wide.add&j scratch.add&j._&k;
           by id;
      run;
%end;
proc datasets library=scratch;
     delete long&j long&j._&k a1a2&j._&k add&j._&k;
quit;
%end;
%end;
%end;
%mend xpose;

%let ns=10;
%xpose;
